import { jsx as c, jsxs as v, Fragment as S } from "react/jsx-runtime";
import i from "clsx";
import _, { useState as R, useEffect as L } from "react";
/*!
  @versini/ui-bubble v2.0.5
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_BUBBLE__ || (window.__VERSINI_UI_BUBBLE__ = {
    version: "2.0.5",
    buildTime: "12/30/2024 05:10 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const U = "av-bubble", T = "av-button", N = "icon", H = "button", O = "link", j = ({
  type: e,
  size: r,
  labelRight: t,
  labelLeft: o,
  align: a
}) => {
  const d = "text-sm font-medium max-h-8 py-0", g = "text-base font-medium max-h-9 py-1", l = "text-lg font-medium max-h-12 py-2";
  switch (e) {
    case H:
      return i("px-4", {
        [d]: r === "small",
        [g]: r === "medium",
        [l]: r === "large"
      });
    case O:
      return i("px-4 text-center", {
        [d]: r === "small",
        [g]: r === "medium",
        [l]: r === "large"
      });
    case N:
      return i("inline-flex items-center", {
        "justify-center": a === "center",
        "justify-start": a === "left",
        "justify-end": a === "right",
        "h-6 w-6 p-0": r === "small" && !(t || o),
        "h-6 px-4 text-sm font-medium": r === "small" && (t || o),
        "h-8 w-8 p-1": r === "medium" && !(t || o),
        "h-8 px-4 text-base font-medium": r === "medium" && (t || o),
        "h-12 w-12 p-2": r === "large" && !(t || o),
        "h-12 px-4 text-lg font-medium": r === "large" && (t || o)
      });
  }
}, W = ({
  mode: e,
  noBackground: r,
  noTruncate: t,
  variant: o,
  radius: a
}) => {
  if (r)
    return i("not-prose", {
      "rounded-full": a === "large",
      "rounded-md": a === "medium",
      "rounded-sm": a === "small"
    });
  if (o === "primary")
    return i("not-prose", {
      "rounded-full": a === "large",
      "rounded-md": a === "medium",
      "rounded-sm": a === "small",
      truncate: !t,
      "bg-action-dark text-copy-light": e === "dark",
      "bg-action-light text-copy-lighter": e === "light",
      "bg-action-dark text-copy-light dark:bg-action-light dark:text-copy-lighter": e === "system",
      "bg-action-light text-copy-lighter dark:bg-action-dark dark:text-copy-light": e === "alt-system"
    });
  if (o === "secondary")
    return i("not-prose", {
      "rounded-full": a === "large",
      "rounded-md": a === "medium",
      "rounded-sm": a === "small",
      truncate: !t,
      "bg-action-dark text-copy-light": e === "light",
      "bg-action-light text-copy-lighter": e === "dark",
      "bg-action-dark text-copy-light dark:bg-action-light dark:text-copy-lighter": e === "alt-system",
      "bg-action-light text-copy-lighter dark:bg-action-dark dark:text-copy-light": e === "system"
    });
  if (o === "danger")
    return i("not-prose", {
      "rounded-full": a === "large",
      "rounded-md": a === "medium",
      "rounded-sm": a === "small",
      truncate: !t,
      "bg-action-danger-dark text-copy-light": e === "dark",
      "bg-action-danger-light text-copy-lighter": e === "light",
      "bg-action-danger-dark text-copy-light dark:bg-action-danger-light dark:text-copy-lighter": e === "system",
      "bg-action-danger-light text-copy-lighter dark:bg-action-danger-dark dark:text-copy-light": e === "alt-system"
    });
  if (o === "selected")
    return i("not-prose", {
      "rounded-full": a === "large",
      "rounded-md": a === "medium",
      "rounded-sm": a === "small",
      truncate: !t,
      "bg-action-selected-dark text-copy-light": e === "dark",
      "bg-action-selected-light text-copy-lighter": e === "light",
      "bg-action-selected-dark text-copy-light dark:bg-action-selected-light dark:text-copy-lighter": e === "system",
      "bg-action-selected-light text-copy-lighter dark:bg-action-selected-dark dark:text-copy-light": e === "alt-system"
    });
}, P = ({
  mode: e,
  disabled: r,
  variant: t
}) => {
  if (r)
    return "";
  if (t === "primary")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "dark",
      "hover:bg-action-light-hover": e === "light",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "alt-system"
    });
  if (t === "secondary")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "light",
      "hover:bg-action-light-hover": e === "dark",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "alt-system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "system"
    });
  if (t === "danger")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-danger-dark-hover": e === "dark",
      "hover:bg-action-danger-light-hover": e === "light",
      "hover:bg-action-danger-dark-hover dark:hover:bg-action-danger-light-hover": e === "system",
      "hover:bg-action-danger-light-hover dark:hover:bg-action-danger-dark-hover": e === "alt-system"
    });
  if (t === "selected")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-selected-dark-hover": e === "dark",
      "hover:bg-action-selected-light-hover": e === "light",
      "hover:bg-action-selected-dark-hover dark:hover:bg-action-selected-light-hover": e === "system",
      "hover:bg-action-selected-light-hover dark:hover:bg-action-selected-dark-hover": e === "alt-system"
    });
}, A = ({
  mode: e,
  disabled: r,
  variant: t
}) => {
  if (r)
    return "";
  if (t === "primary")
    return i("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "dark",
      "active:bg-action-light-active": e === "light",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "alt-system"
    });
  if (t === "secondary")
    return i("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "light",
      "active:bg-action-light-active": e === "dark",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "alt-system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "system"
    });
  if (t === "danger")
    return i("active:text-copy-lighter-active", {
      "active:bg-action-danger-dark-active": e === "dark",
      "active:bg-action-danger-light-active": e === "light",
      "active:bg-action-danger-dark-active dark:active:bg-action-danger-light-active": e === "system",
      "active:bg-action-danger-light-active dark:active:bg-action-danger-dark-active": e === "alt-system"
    });
  if (t === "selected")
    return i("active:text-copy-lighter-active", {
      "active:bg-action-selected-dark-active": e === "dark",
      "active:bg-action-selected-light-active": e === "light",
      "active:bg-action-selected-dark-active dark:active:bg-action-selected-light-active": e === "system",
      "active:bg-action-selected-light-active dark:active:bg-action-selected-dark-active": e === "alt-system"
    });
}, G = ({
  mode: e,
  noBorder: r,
  variant: t
}) => {
  if (r)
    return "border border-transparent";
  if (t === "primary")
    return i("border", {
      "border-border-dark": e === "dark",
      "border-border-accent": e === "light",
      "border-border-dark dark:border-border-accent": e === "system",
      "border-border-accent dark:border-border-dark": e === "alt-system"
    });
  if (t === "secondary")
    return i("border", {
      "border-border-dark": e === "light",
      "border-border-accent": e === "dark",
      "border-border-dark dark:border-border-accent": e === "alt-system",
      "border-border-accent dark:border-border-dark": e === "system"
    });
  if (t === "danger")
    return i("border", {
      "border-border-danger-dark": e === "dark",
      "border-border-danger-medium": e === "light",
      "border-border-danger-dark dark:border-border-danger-medium": e === "system",
      "border-border-danger-medium dark:border-border-danger-dark": e === "alt-system"
    });
  if (t === "selected")
    return i("border", {
      "border-border-selected-dark": e === "dark",
      "border-border-selected-medium": e === "light",
      "border-border-selected-dark dark:border-border-selected-medium": e === "system",
      "border-border-selected-medium dark:border-border-selected-dark": e === "alt-system"
    });
}, q = ({
  focusMode: e
}) => i("focus:outline", "focus:outline-2", "focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), z = ({
  type: e,
  className: r,
  raw: t,
  mode: o,
  focusMode: a,
  disabled: d,
  fullWidth: g,
  size: l,
  noBorder: h,
  labelRight: m,
  labelLeft: b,
  noBackground: u,
  variant: n,
  noTruncate: s,
  align: p,
  radius: f
}) => (n || (n = "primary"), t ? i(T, r) : i(
  T,
  W({
    mode: o,
    variant: n,
    noBackground: u,
    noTruncate: s,
    radius: f
  }),
  j({ type: e, size: l, labelRight: m, labelLeft: b, align: p }),
  G({ mode: o, variant: n, noBorder: h }),
  q({ focusMode: a }),
  P({ mode: o, variant: n, disabled: d }),
  A({ mode: o, variant: n, disabled: d }),
  {
    "w-full": g,
    "disabled:cursor-not-allowed disabled:opacity-50": d
  },
  r
)), D = (e, r, t) => {
  var o;
  !r && (!document.activeElement || document.activeElement !== e.currentTarget) && typeof ((o = e == null ? void 0 : e.currentTarget) == null ? void 0 : o.focus) == "function" && e.currentTarget.focus(), typeof t == "function" && t(e);
}, I = _.forwardRef((e, r) => {
  const { onClick: t, noInternalClick: o = !1, ...a } = e;
  return /* @__PURE__ */ c(
    "button",
    {
      ref: r,
      onClick: (d) => {
        D(d, o, t);
      },
      ...a
    }
  );
});
I.displayName = "BaseButton";
const C = _.forwardRef(
  ({
    children: e,
    disabled: r = !1,
    mode: t = "system",
    focusMode: o = "system",
    fullWidth: a = !1,
    className: d,
    type: g = "button",
    raw: l = !1,
    noBorder: h = !1,
    "aria-label": m,
    label: b,
    size: u = "medium",
    labelRight: n,
    labelLeft: s,
    noBackground: p = !1,
    align: f = "center",
    radius: k = "large",
    ...y
  }, x) => {
    const w = z({
      type: N,
      mode: t,
      focusMode: o,
      fullWidth: a,
      disabled: r,
      raw: l,
      className: d,
      noBorder: h,
      size: u,
      labelRight: n,
      labelLeft: s,
      noBackground: p,
      align: f,
      radius: k
    }), B = i({
      "text-copy-accent-dark": t === "light" && !l,
      "text-copy-light": t === "dark" && !l,
      "text-copy-accent-dark dark:text-copy-light": t === "alt-system" && !l,
      "text-copy-light dark:text-copy-accent-dark": t === "system" && !l
    });
    return /* @__PURE__ */ v(
      I,
      {
        ref: x,
        className: w,
        disabled: r,
        type: g,
        "aria-label": m || b,
        ...y,
        children: [
          s && /* @__PURE__ */ c("span", { className: "pr-2", children: s }),
          /* @__PURE__ */ c("div", { className: B, children: e }),
          n && /* @__PURE__ */ c("span", { className: "pl-2", children: n })
        ]
      }
    );
  }
);
C.displayName = "ButtonIcon";
/*!
  @versini/ui-button v3.0.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_BUTTON__ || (window.__VERSINI_UI_BUTTON__ = {
    version: "3.0.0",
    buildTime: "12/30/2024 05:10 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const F = _.forwardRef(
  ({
    children: e,
    disabled: r = !1,
    mode: t = "system",
    focusMode: o = "system",
    fullWidth: a = !1,
    className: d,
    type: g = "button",
    raw: l = !1,
    noBorder: h = !1,
    "aria-label": m,
    label: b,
    size: u = "medium",
    labelRight: n,
    labelLeft: s,
    noBackground: p = !1,
    align: f = "center",
    active: k = !1,
    radius: y = "large",
    ...x
  }, w) => {
    const B = z({
      type: N,
      mode: t,
      focusMode: o,
      fullWidth: a,
      disabled: r,
      raw: l,
      className: d,
      noBorder: h,
      size: u,
      labelRight: n,
      labelLeft: s,
      noBackground: p,
      align: f,
      radius: y
    }), V = i({
      "text-copy-accent-dark": t === "light" && !l,
      "text-copy-light": t === "dark" && !l,
      "text-copy-accent-dark dark:text-copy-light": t === "alt-system" && !l,
      "text-copy-light dark:text-copy-accent-dark": t === "system" && !l
    }), E = k ? i(
      "relative",
      "focus-within:static",
      "focus-within:after:border-transparent",
      "after:absolute",
      "after:content-['']",
      "after:border-b-2",
      "after:bottom-[-4px]",
      "after:left-0",
      "after:right-0",
      {
        "after:border-table-dark": t === "dark",
        "after:border-table-light": t === "light",
        "after:border-table-dark dark:after:border-table-light": t === "system",
        "after:border-table-light dark:after:border-table-dark": t === "alt-system"
      }
    ) : "";
    return /* @__PURE__ */ c("div", { className: E, children: /* @__PURE__ */ v(
      I,
      {
        ref: w,
        className: B,
        disabled: r,
        type: g,
        "aria-label": m || b,
        ...x,
        children: [
          s && /* @__PURE__ */ c("span", { className: "pr-2", children: s }),
          /* @__PURE__ */ c("div", { className: V, children: e }),
          n && /* @__PURE__ */ c("span", { className: "pl-2", children: n })
        ]
      }
    ) });
  }
);
F.displayName = "ButtonSort";
const M = ({
  children: e,
  fill: r,
  viewBox: t,
  className: o,
  defaultViewBox: a,
  size: d,
  title: g,
  semantic: l = !1,
  ...h
}) => {
  const m = i(d, o);
  return /* @__PURE__ */ v(S, { children: [
    /* @__PURE__ */ c(
      "svg",
      {
        xmlns: "http://www.w3.org/2000/svg",
        className: m,
        viewBox: t || a,
        fill: r || "currentColor",
        role: "img",
        "aria-hidden": !l,
        focusable: !1,
        ...h,
        children: e
      }
    ),
    g && l && /* @__PURE__ */ c("span", { className: "sr-only", children: g })
  ] });
};
/*!
  @versini/ui-svgicon v3.0.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SVGICON__ || (window.__VERSINI_UI_SVGICON__ = {
    version: "3.0.0",
    buildTime: "12/30/2024 05:10 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const J = ({
  className: e,
  viewBox: r,
  title: t,
  monotone: o,
  ...a
}) => /* @__PURE__ */ v(
  M,
  {
    defaultViewBox: "0 0 448 512",
    size: "size-5",
    viewBox: r,
    className: e,
    title: t || "Copied",
    ...a,
    children: [
      /* @__PURE__ */ c(
        "path",
        {
          opacity: "0.4",
          d: "M64 32C28.7 32 0 60.7 0 96V416c0 35.3 28.7 64 64 64H384c35.3 0 64-28.7 64-64V96c0-35.3-28.7-64-64-64H64zM337 209L209 337c-9.4 9.4-24.6 9.4-33.9 0l-64-64c-9.4-9.4-9.4-24.6 0-33.9s24.6-9.4 33.9 0l47 47L303 175c9.4-9.4 24.6-9.4 33.9 0s9.4 24.6 0 33.9z"
        }
      ),
      /* @__PURE__ */ c("path", { d: "M337 175c9.4 9.4 9.4 24.6 0 33.9L209 337c-9.4 9.4-24.6 9.4-33.9 0l-64-64c-9.4-9.4-9.4-24.6 0-33.9s24.6-9.4 33.9 0l47 47L303 175c9.4-9.4 24.6-9.4 33.9 0z" })
    ]
  }
), K = ({
  className: e,
  viewBox: r,
  title: t,
  monotone: o,
  ...a
}) => /* @__PURE__ */ c(
  M,
  {
    defaultViewBox: "0 0 512 512",
    size: "size-5",
    viewBox: r,
    className: e,
    title: t || "Copy",
    ...a,
    children: /* @__PURE__ */ c("path", { d: "M64 464H288c8.8 0 16-7.2 16-16V384h48v64c0 35.3-28.7 64-64 64H64c-35.3 0-64-28.7-64-64V224c0-35.3 28.7-64 64-64h64v48H64c-8.8 0-16 7.2-16 16V448c0 8.8 7.2 16 16 16zM224 304H448c8.8 0 16-7.2 16-16V64c0-8.8-7.2-16-16-16H224c-8.8 0-16 7.2-16 16V288c0 8.8 7.2 16 16 16zm-64-16V64c0-35.3 28.7-64 64-64H448c35.3 0 64 28.7 64 64V288c0 35.3-28.7 64-64 64H224c-35.3 0-64-28.7-64-64z" })
  }
);
/*!
  @versini/ui-icons v3.0.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_ICONS__ || (window.__VERSINI_UI_ICONS__ = {
    version: "3.0.0",
    buildTime: "12/30/2024 05:10 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const Q = () => "p-4 max-w-md md:max-w-2xl", X = ({ kind: e }) => i({
  "bg-surface-lighter dark:bg-surface-dark": e === "left",
  "bg-surface-accent": e === "right"
}), Y = ({ kind: e }) => i(
  "prose prose-dark dark:prose-lighter prose-p:my-3 prose-blockquote:my-3 prose-ol:my-3 prose-ul:my-3 prose-ul:prose-li:marker:text-black",
  {
    "text-copy-lighter": e === "right"
  }
), Z = ({ kind: e }) => i("rounded-b-xl", {
  "rounded-tr-xl": e === "left",
  "rounded-tl-xl": e === "right"
}), $ = ({
  kind: e,
  className: r
}) => {
  const t = i(
    U,
    "flex items-start",
    {
      "flex-row-reverse": e === "right"
    },
    r
  ), o = i(
    "flex flex-col empty:hidden",
    Q(),
    Y({ kind: e }),
    X({ kind: e }),
    Z({ kind: e })
  ), a = "pr-2 pt-1 text-end text-xs text-copy-light", d = i("flex flex-col-reverse gap-2 sm:flex-row", {
    "ml-2": e === "left",
    "mr-2": e === "right"
  });
  return {
    wrapper: t,
    main: o,
    footer: a,
    copyButton: d
  };
}, ae = ({
  children: e,
  kind: r = "left",
  className: t,
  footer: o,
  rawFooter: a,
  copyToClipboard: d,
  copyToClipboardFocusMode: g = "system",
  copyToClipboardMode: l = "system"
}) => {
  const [h, m] = R(!1), b = $({ kind: r, className: t }), u = !!d && (typeof d == "function" || typeof d == "string" || typeof e == "string"), n = () => {
    m(!0), typeof d == "function" ? d(e) : typeof d == "string" ? navigator.clipboard.writeText(d) : typeof e == "string" && navigator.clipboard.writeText(e);
  };
  return L(() => {
    let s;
    return h && (s = window.setTimeout(() => {
      m(!1);
    }, 3e3)), () => {
      clearTimeout(s);
    };
  }, [h]), /* @__PURE__ */ v("div", { className: b.wrapper, children: [
    /* @__PURE__ */ v("div", { children: [
      /* @__PURE__ */ c("div", { className: b.main, children: e }),
      o && Object.keys(o).map((s) => o[s] ? /* @__PURE__ */ c("div", { className: "prose-p:m-0", children: /* @__PURE__ */ v("p", { className: b.footer, children: [
        s,
        ": ",
        o[s]
      ] }) }, `-${s}`) : null),
      a && a
    ] }),
    u && /* @__PURE__ */ c("div", { className: b.copyButton, children: /* @__PURE__ */ c(
      C,
      {
        noBorder: !0,
        noBackground: !0,
        size: "small",
        mode: l,
        focusMode: g,
        label: h ? "Copied to clipboard" : "Copy to clipboard",
        onClick: n,
        disabled: h,
        children: h ? /* @__PURE__ */ c(J, { className: "size-3" }) : /* @__PURE__ */ c(K, { className: "size-3" })
      }
    ) })
  ] });
};
export {
  U as BUBBLE_CLASSNAME,
  ae as Bubble
};
